package com.hxstrive.demo_netflix_feign.controller;

import com.hxstrive.demo_netflix_feign.dto.CommonReturn;
import com.hxstrive.demo_netflix_feign.entity.User;
import com.hxstrive.demo_netflix_feign.feign.*;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 控制器
 * @author hxstrive.com
 */
@RestController
public class FeignController {

    @GetMapping("/")
    public String index() {
//        return SimpleFeign.create().get2(Arrays.asList("one", "two", "three"));
//        return SimpleFeign.create().get3("%2Fsimple%2Fhello");
//        return SimpleFeign.create().param1("e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855");
//        return SimpleFeign.create().param2("e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855");
//        return SimpleFeign.create().param3("hello! body");
//        return SimpleFeign.create().param4("hello world");
//        return SimpleFeign.create().header1("hello world");

//        Map<String,String> args = new HashMap<>();
//        args.put("id", "1");
//        args.put("name", "张三");
//        return SimpleFeign.create().body1(args);

//        return SimpleFeign.createJson().body2(User.builder().id(100L).name("Tom").age(20).build()).toString();

//        return SimpleFeign.createJson().body3().toString();

//        return SimpleFeign.create().ignore();


//        Map<String,String> headers = new HashMap<>();
//        headers.put("Authorization", "Bearer e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855");
//        headers.put("Content-Type", "text/plain");
//        return SimpleFeign.create().header2(headers);

//        return SimpleFeign.createJson().query(User.builder().id(100L).name("Tom").age(20).build()).toString();

//        return InterceptorFeign.create().interceptor("hello");

//        return EncodeDecodeFeign.create().encode(User.builder().id(100L).name("Tom").age(20).build()).toString();

//        return LogFeign.create().encode(User.builder().id(100L).name("Tom").age(20).build()).toString();

        return RibbonFeign.create().hello();
    }

    @GetMapping("/demo1")
    public String demo1() {
        return SimpleFeign.create().get();
    }

    @GetMapping("/demo2")
    public CommonReturn<List<User>> demo2() {
        return UserFeign.create().getAllUsers();
    }

    @GetMapping("/demo3")
    public CommonReturn<User> demo3(@RequestParam Long id) {
        return UserFeign.create().getUserById(id);
    }

    @GetMapping("/demo4")
    public CommonReturn<User> demo4(@RequestParam Long id, @RequestParam String name, @RequestParam Integer age) {
        return UserFeign.create().createUser(User.builder().id(id).name(name).age(age).build());
    }

    @GetMapping("/demo5")
    public CommonReturn<User> demo5(@RequestParam Long id, @RequestParam String name, @RequestParam Integer age) {
        return UserFeign.create().updateUser(id, User.builder().id(id).name(name).age(age).build());
    }

    @GetMapping("/demo6")
    public CommonReturn<String> demo6(@RequestParam Long id) {
        return UserFeign.create().deleteUser(id);
    }


    @GetMapping("/demo7")
    public CommonReturn<List<User>> demo7() {
        return UserRestfulFeign.create().getAllUsers();
    }

    @GetMapping("/demo8")
    public CommonReturn<User> demo8(@RequestParam Long id) {
        return UserRestfulFeign.create().getUserById(id);
    }

    @GetMapping("/demo9")
    public CommonReturn<User> demo9(@RequestParam Long id, @RequestParam String name, @RequestParam Integer age) {
        return UserRestfulFeign.create().createUser(User.builder().id(id).name(name).age(age).build());
    }

    @GetMapping("/demo10")
    public CommonReturn<User> demo10(@RequestParam Long id, @RequestParam String name, @RequestParam Integer age) {
        return UserRestfulFeign.create().updateUser(id, User.builder().id(id).name(name).age(age).build());
    }

    @GetMapping("/demo11")
    public CommonReturn<String> demo11(@RequestParam Long id) {
        return UserRestfulFeign.create().deleteUser(id);
    }

}
