package com.hxstrive.demo_netflix_feign.feign;

import com.hxstrive.demo_netflix_feign.entity.User;
import feign.*;
import feign.jackson.JacksonDecoder;
import feign.jackson.JacksonEncoder;
import feign.slf4j.Slf4jLogger;

/**
 * 用户 Feign
 * @author hxstrive.com
 */
@Headers("Custom-Header: SimpleFeign.java")
public interface LogFeign {

    // 定义获取用户信息的方法
    @RequestLine("POST /simple/encode")
    @Headers("Content-Type: application/json")
    User encode(User user);

    // 创建Feign客户端实例的静态方法
    static LogFeign create() {
        return Feign.builder()
                .encoder(new JacksonEncoder())
                .decoder(new JacksonDecoder())
                .logger(new Slf4jLogger())
                .contract(new Contract.Default())
                .target(LogFeign.class, "http://localhost:8090");
    }

}
