package com.hxstrive.demo_netflix_feign.feign;

import com.netflix.config.ConfigurationManager;
import feign.Contract;
import feign.Feign;
import feign.RequestLine;
import feign.codec.Decoder;
import feign.codec.Encoder;
import feign.ribbon.LoadBalancingTarget;
import feign.ribbon.RibbonClient;

public interface RibbonFeign {

    // 定义获取用户信息的方法
    @RequestLine("GET /hello")
    String hello();

    // 创建Feign客户端实例的静态方法
    static RibbonFeign create() {
        // 见 AppReadyListener 类
        /*try {
            ConfigurationManager.loadPropertiesFromResources("ribbon.properties");
            System.out.println(ConfigurationManager.getConfigInstance().getProperty("user.ribbon.listOfServers"));
        } catch (Exception e) {
            e.printStackTrace();
        }*/

        // RibbonClient 用法
        /*return Feign.builder()
                .client(RibbonClient.create())
                .encoder(new Encoder.Default())
                .decoder(new Decoder.Default())
                .contract(new Contract.Default())
                .target(RibbonFeign.class, "http://user");*/

        // LoadBalancingTarget 用法
        return Feign.builder()
                .encoder(new Encoder.Default())
                .decoder(new Decoder.Default())
                .contract(new Contract.Default())
                .target(LoadBalancingTarget.create(RibbonFeign.class, "http://user"));
    }

}
