package com.hxstrive.demo_netflix_feign.listener;

import com.netflix.config.ConfigurationManager;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.event.EventListener;

/**
 * APP 启动完成监听器
 * @author hxstrive.com
 * @since 1.0.0  2024/11/5 15:30
 */
public class AppReadyListener {

    @EventListener
    public void onApplicationReady(ApplicationReadyEvent event) {
        System.out.println("## 应用已经完全准备好，可以接收请求啦！");

        // 可以在这里添加检查服务是否可用、预热缓存等逻辑
        // ribbon 配置文件加载
        try {
            ConfigurationManager.loadPropertiesFromResources("ribbon.properties");
            System.out.println(ConfigurationManager.getConfigInstance().getProperty("user.ribbon.listOfServers"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
